<map>
		<node ID="root" TEXT="IO总结">		<node TEXT="比特/字节/字符" ID="38e1686fc7d74f0a7" STYLE="bubble" POSITION="right">
		<node TEXT="比特(bit) =（经过分组编码）=> 字节(Byte) =（经过字符集编码）=> 字符" ID="22d1686fc834b006a" STYLE="fork">
		</node>
		<node TEXT="1.比特(Bit):最小的二进制单位 ，是计算机的操作部分。取值0或者1" ID="551686fc853c20bf1" STYLE="fork">
		</node>
		<node TEXT="2.字节(Byte):是计算机操作数据的最小单位由8位bit组成 取值（-128-127）" ID="3a71686fc853c20242" STYLE="fork">
		</node>
		<node TEXT="3.字符(Char):是用户的可读写的最小单位，在Java里面由16位bit组成 取值（0-65535）" ID="2381686fc853c20573" STYLE="fork">
		</node>
		</node>
		<node TEXT="IO和流" ID="3611686fc8886a09e" STYLE="bubble" POSITION="right">
		<node TEXT="IO是指计算机与外部世界或者一个程序与计算机的其余部分的之间的接口。在 Java 编程中，直到最近一直使用 流 的方式完成 I/O。所有 I/O 都被视为单个的字节的移动，通过一个称为 Stream 的对象一次移动一个字节。流 I/O 用于与外部世界接触。它也在内部使用，用于将对象转换为字节，然后再转换回对象" ID="31b1686fc8a00f0aa" STYLE="fork">
		</node>
		<node TEXT="流是一串连续不断的数据的集合，就象水管里的水流，在水管的一端一点一点地供水，而在水管的另一端看到的是一股连续不断的水流。数据写入程序可以是一段、一段地向数据流管道中写入数据，这些数据段会按先后顺序形成一个长的数据流。对数据读取程序来说，看不到流在写入时的分段情况，每次可以读取其中的任意长度的数据，但只能先读取前面的数据后，再读取后面的数据。" ID="14b1686fc8a0e30a51" STYLE="fork">
		</node>
		</node>
		<node TEXT="流的分类" ID="3381686fc943ae006" STYLE="bubble" POSITION="right">
		<node TEXT="1.按照流中操作单元划分" ID="2361686fc9612206a" STYLE="fork">
		<node TEXT="字节流：操作byte类型数据，数据单元是8位的字节。主要操作类是OutputStream、InputStream的子类；不用缓冲区，直接对文件本身操作。" ID="621686fc9732f193" STYLE="fork">
		</node>
		<node TEXT="字符流：操作字符类型数据，字符流操作的是数据单元为16位的字符。主要操作类是Reader、Writer的子类；使用缓冲区缓冲字符，不关闭流就不会输出任何内容。" ID="1581686fc9750602c1" STYLE="fork">
		</node>
		</node>
		<node TEXT="2.按照数据的流向划分" ID="1071686fc97c47153" STYLE="fork">
		<node TEXT="输入流：数据从硬盘到内存的数据流" ID="22c1686fc99d4a03c" STYLE="fork">
		</node>
		<node TEXT="输出流：数据从内存到硬盘的数据流" ID="2281686fc99d4a0b11" STYLE="fork">
		</node>
		</node>
		<node TEXT="3.字节流与字符流的转换" ID="421686fc9e3b6188" STYLE="fork">
		<node TEXT="OutputStreamWriter：是Writer的子类，将输出的字符流变为字节流，即将一个字符流的输出对象变为字节流输出对象。" ID="2c61686fcb2ade141" STYLE="fork">
		</node>
		<node TEXT="InputStreamReader：是Reader的子类，将输入的字节流变为字符流，即将一个字节流的输入对象变为字符流的输入对象。" ID="2ca1686fcb6429189" STYLE="fork">
		</node>
		</node>
		</node>
		<node TEXT="Java中IO的分类" ID="30216878936f4d0ca" STYLE="bubble" POSITION="right">
		<node TEXT="BIO" ID="33916873482d860cf" STYLE="fork">
		<node TEXT="Block IO,即同步并阻塞的IO，是传统java.IO包下的代码实现" ID="1fc16873486376093" STYLE="fork">
		</node>
		<node TEXT="服务器实现模式为一个连接一个线程，即客户端有连接请求时服务器端就需要启动一个线程进行处理" ID="221168734ace03164" STYLE="fork">
		</node>
		<node TEXT="如果这个连接不做任何事情会造成不必要的线程开销，当然可以通过线程池机制改善。 " ID="ad168734aeb9409" STYLE="fork">
		</node>
		<node TEXT="" ID="37c168746022b415" STYLE="fork">
		</node>
		</node>
		<node TEXT="NIO" ID="322168734a0acb0b6" STYLE="fork">
		<node TEXT="以块的方式实现IO，将最耗时的 I/O 操作(即填充和提取缓冲区)转移回操作系统，因而可以极大地提高速度。" ID="a4168735672d703d" STYLE="fork">
		</node>
		<node TEXT="但相应的缺少面向流的IO所具有的优雅性与简单性。" ID="384168735673e10651" STYLE="fork">
		</node>
		<node TEXT="同步非阻塞IO" ID="2d7168734a268e056" STYLE="fork">
		<node TEXT="服务器实现模式为一个请求一个线程，即客户端发送的连接请求都会注册到多路复用器(selector)上,所有的连接实际上只对应一个线程." ID="36f168734b3b1d0ef" STYLE="fork">
		</node>
		</node>
		<node TEXT="异步阻塞IO" ID="dd1687356a8d001d" STYLE="fork">
		<node TEXT="应用发起一个IO操作以后，不等待内核IO操作的完成，等内核完成IO操作以后会通知应用程序" ID="cd1687356b1070bf" STYLE="fork">
		</node>
		<node TEXT="通过select系统调用来完成的，而select函数本身的实现方式是阻塞的，而采用select函数有个好处就是它可以同时监听多个文件句柄" ID="2321687356fc97175" STYLE="fork">
		</node>
		</node>
		<node TEXT="重要概念" ID="36516874a0ab7014b" STYLE="fork">
		<node TEXT="Channel" ID="30c168749fc588026" STYLE="fork">
		<node TEXT="通道，是双向的，可读，写或同时用于读写" ID="2f216874cf62ac0ca" STYLE="fork">
		</node>
		<node TEXT="常用的通道类型" ID="25e16874d0304c09b" STYLE="fork">
		<node TEXT="FileChannel，一般用于本地的读写数据。" ID="17b16874d25da115a" STYLE="fork">
		<node TEXT="无法被Selector复用，无法注册到Selector，无法切换到非阻塞状态" ID="23c16874d09e250cc" STYLE="fork">
		</node>
		</node>
		<node TEXT="SelectableChannel，一般用于注册到Selector上被监听事件" ID="33616874d26773013" STYLE="fork">
		<node TEXT="可以切换为非阻塞configureBlocking(false)" ID="4d16874d30353152" STYLE="fork">
		</node>
		<node TEXT="" ID="39b16874d3850317a" STYLE="fork">
		</node>
		</node>
		</node>
		</node>
		<node TEXT="Buffer" ID="38b16874a025390d7" STYLE="fork">
		<node TEXT="底层依然是数组，但是缓冲区实现了对数据读写的灵活性，因此必须理解一下4个概念" ID="36416874ad073917a" STYLE="fork">
		<node TEXT="mark <= position <= limit <= capacity" ID="1f816874b1381718d" STYLE="fork">
		</node>
		<node TEXT="position：当前读写到的位置。比如读了5个字节，则position为5，指向数组的第6个位置。" ID="34216874af8bbd12c" STYLE="fork">
		</node>
		<node TEXT="limit：表明（从缓冲区写入通道）还有多少数据需要取出，（从通道写入缓冲）还有多少空间可以放入" ID="1c916874af8c901121" STYLE="fork">
		</node>
		<node TEXT="capacity：缓冲区的最大容量，即数组的大小" ID="2a516874af8c900672" STYLE="fork">
		</node>
		<node TEXT="mark：标志位，记录下当前位置，初始为-1" ID="2bf16874af8c901333" STYLE="fork">
		</node>
		</node>
		<node TEXT="最常见的是ByteBuffer。但java基本类型都有对应的Buffer，操作都是完全一样的，只是操作的数据类型不同" ID="6216874a1d1fe0d5" STYLE="fork">
		</node>
		<node TEXT="通用方法" ID="1cc16874b3dee701f" STYLE="fork">
		<node TEXT="mark()：标记当前位置，将position赋值给mark,即标记当前位置;" ID="2d316874b459c8138" STYLE="fork">
		</node>
		<node TEXT="reset():mark不小于0，将mark重新赋值给position" ID="7f16874b3fdc80dd" STYLE="fork">
		</node>
		<node TEXT="clear()：清空缓冲区，实际上初始化mark=-1 ，POSITION=0和limit=capacity，让数据写入缓冲区从头开始，覆盖原有的" ID="20116874b4dc31197" STYLE="fork">
		</node>
		<node TEXT="filp()：切换为读，即从写入缓冲到读取缓冲，limit=position，mark=-1，POSITION=0，" ID="2116874b60a3d07b" STYLE="fork">
		</node>
		<node TEXT="rewind()：倒回初始，重新开始读取缓冲，即POSITION=0，mark=-1，limit不变" ID="21d16874b86d370e6" STYLE="fork">
		</node>
		<node TEXT="remaining()：返回limit-position" ID="21816874b9c13d0ba" STYLE="fork">
		</node>
		<node TEXT="至于分配空间与获取数据等操作，与实现类操作的数据类型和底层数组类型有关" ID="3316874bf3d02026" STYLE="fork">
		</node>
		</node>
		<node TEXT="只读缓冲区：只读，不写。无法从只读转为可写的缓冲区。调用asReadOnlyBuffer()返回一个原缓冲区相同的只读缓冲区，共享数据。" ID="15416874c3551917a" STYLE="fork">
		</node>
		<node TEXT="缓冲区分片：调用slice()以原缓冲区的position和limit为起始和结束位，生成一个与原缓冲区共享区间数据的分片缓冲区。" ID="10816874c5173a182" STYLE="fork">
		</node>
		</node>
		<node TEXT="Selector" ID="2e316874a05bfe15e" STYLE="fork">
		<node TEXT="通道注册到选择器上，选择器监控通道" ID="1d816874d55c7a007" STYLE="fork">
		</node>
		<node TEXT="当某一个通道上，某一个事件准备就绪时，那么选择器才会将这个通道分配到服务器端一个或多个线程上，再继续运行。" ID="19a16874d58641192" STYLE="fork">
		</node>
		<node TEXT="选择器的使用" ID="9216874d645c118f" STYLE="fork">
		<node TEXT="1.创建一个Selector： Selector.open()" ID="25916874d69109087" STYLE="fork">
		</node>
		<node TEXT="2.注册通道：channel.register(Selector sel, int ops)，ops为监听事件的选择键（SelectionKey）" ID="35416874d70cd014e" STYLE="fork">
		<node TEXT="读 : SelectionKey.OP_READ （ 1）" ID="1bd16874d86276035" STYLE="fork">
		</node>
		<node TEXT="写 : SelectionKey.OP_WRITE （ 4）" ID="2e516874d86821014" STYLE="fork">
		</node>
		<node TEXT="连接 : SelectionKey.OP_CONNECT （ 8）" ID="38116874d86d990fe" STYLE="fork">
		</node>
		<node TEXT="接收 : SelectionKey.OP_ACCEPT （ 16）" ID="20616874d84031088" STYLE="fork">
		</node>
		<node TEXT="若注册多个事件，用“|”连接" ID="23b16874d89ce918c" STYLE="fork">
		</node>
		</node>
		<node TEXT="" ID="17e16874dc075f07c" STYLE="fork">
		</node>
		</node>
		</node>
		</node>
		<node TEXT="阻塞实现" ID="27e16874768c9a15" STYLE="fork">
		</node>
		<node TEXT="非阻塞实现" ID="1816874fae37a169" STYLE="fork">
		</node>
		</node>
		<node TEXT="AIO" ID="f8168734a19cc11b" STYLE="fork">
		<node TEXT="异步非阻塞IO" ID="2ea168735990550cf" STYLE="fork">
		</node>
		<node TEXT="用户进程只需要发起一个IO操作然后立即返回，等IO操作真正的完成以后，应用程序会得到IO操作完成的通知，此时用户进程只需要对数据进行处理就好了，不需要进行实际的IO读写操作，因为真正的IO读取或者写入操作已经由内核完成了。" ID="178168735a0cc70ba" STYLE="fork">
		</node>
		<node TEXT="示例,以AsynchronousFileChannel为例" ID="2a3168785e3a8c0e7" STYLE="fork">
		</node>
		</node>
		<node TEXT="三者的适用场景" ID="a81687894c30818b" STYLE="fork">
		<node TEXT="BIO方式适用于连接数目比较小且固定的架构，这种方式对服务器资源要求比较高，并发局限于应用中，JDK1.4以前的唯一选择，但程序直观简单易理解。" ID="25616878952b77159" STYLE="fork">
		</node>
		<node TEXT="NIO方式适用于连接数目多且连接比较短（轻操作）的架构，比如聊天服务器，并发局限于应用中，编程比较复杂，JDK1.4开始支持。" ID="3bf16878956f4c1211" STYLE="fork">
		</node>
		<node TEXT="AIO方式使用于连接数目多且连接比较长（重操作）的架构，比如相册服务器，充分调用OS参与并发操作，编程比较复杂，JDK7开始支持。" ID="11c16878956f4c0a22" STYLE="fork">
		</node>
		</node>
		</node>
		<node TEXT="阻塞与同步" ID="21616878a809ce04" STYLE="bubble" POSITION="right">
		<node TEXT="同步与异步" ID="2c916878978cc6175" STYLE="fork">
		<node TEXT="同步，异步，是描述被调用方的。" ID="3af1687897a57b094" STYLE="fork">
		</node>
		<node TEXT="调用方在得到返回之前所做的事情不一样。" ID="2f81687897cf450811" STYLE="fork">
		</node>
		<node TEXT="" ID="2221687897f82d074" STYLE="fork">
		</node>
		</node>
		<node TEXT="阻塞与非阻塞" ID="2d81687898bfed0b9" STYLE="fork">
		<node TEXT="阻塞，非阻塞，是描述调用方的。" ID="24f1687898d30c01" STYLE="fork">
		</node>
		<node TEXT="被调用方对于发起请求的处理不一样." ID="1651687898f8400f51" STYLE="fork">
		</node>
		<node TEXT="如果是阻塞，A在发出调用后，要一直等待，等着B返回结果。" ID="cd1687899089f072" STYLE="fork">
		</node>
		<node TEXT="如果是非阻塞，A在发出调用后，不需要等待，可以去做自己的事情。" ID="12c168789917db0ef1" STYLE="fork">
		</node>
		</node>
		</node>
		<node TEXT="IO模型" ID="33216878a7d9f112c" STYLE="bubble" POSITION="right">
		<node TEXT="阻塞式IO模型" ID="29c16878ae6b8c036" STYLE="fork">
		<node TEXT="进程发起IO系统调用后，进程被阻塞，转到内核空间处理，整个IO处理(等待数据准备,然后再拷贝到用户空间)完毕后返回进程。操作成功则进程获取到数据。" ID="27216878af6f7a0d5" STYLE="fork">
		</node>
		<node TEXT="特点" ID="36a16878af8412013" STYLE="fork">
		<node TEXT="进程阻塞挂起不消耗CPU资源，及时响应每个操作；" ID="26716878af871a0e4" STYLE="fork">
		</node>
		<node TEXT="实现难度低、开发应用较容易；" ID="39a16878af97801381" STYLE="fork">
		</node>
		<node TEXT="适用并发量小的网络应用开发；" ID="2f416878af97800052" STYLE="fork">
		</node>
		</node>
		<node TEXT="" ID="29e16878af9ccb131" STYLE="fork">
		</node>
		</node>
		<node TEXT="非阻塞IO模型" ID="17616878af0a2a03c" STYLE="fork">
		<node TEXT="阻塞与非阻塞描述的是用户线程调用内核IO操作的方式。" ID="1a116878b141a40b6" STYLE="fork">
		</node>
		<node TEXT="用户进程发起IO系统调用后,如果为空数据,不会进行等待,而是会立即返回未准备就绪的信号.用户程序根据情况执行下一步操作." ID="de16878b143af06a1" STYLE="fork">
		</node>
		<node TEXT="但用户程序实际上还是阻塞在请求内核的这个阶段上." ID="3016878b143af0322" STYLE="fork">
		</node>
		<node TEXT="" ID="2b816878b198fb01e" STYLE="fork">
		</node>
		</node>
		<node TEXT="IO复用模型" ID="19716878af0c1c083" STYLE="fork">
		<node TEXT="多路复用IO模型是目前使用得比较多的模型。Java NIO实际上就是多路复用IO。" ID="f716878b1b702129" STYLE="fork">
		</node>
		<node TEXT="在多路复用IO模型中，会有一个线程不断去轮询多个socket的状态，只有当socket真正有读写事件时，才真正调用实际的IO读写操作。" ID="19216878b468ac0ba" STYLE="fork">
		</node>
		<node TEXT="系统不需要建立新的进程或者线程，也不必维护这些线程和进程，并且只有在真正有socket读写事件进行时，才会使用IO资源，减少了资源占用。" ID="20616878b3f12a11b" STYLE="fork">
		</node>
		<node TEXT="相比较于 多线程+阻塞IO,减少一个连接对应一个线程的资源浪费.而且在一个线程中处理一个长连接的话,如果后面有很多连接,会造成性能瓶颈。而多路复用IO模式，通过一个线程就可以管理多个socket，只有当socket真正有读写事件发生才会占用资源来进行实际的读写操作。因此，多路复用IO比较适合连接数比较多的情况。" ID="1a816878b4abea047" STYLE="fork">
		</node>
		<node TEXT="多路复用IO为何比非阻塞IO模型的效率高？是因为在非阻塞IO中，不断地询问socket状态时通过用户线程去进行的。而在多路复用IO中，轮询每个socket状态是内核在进行的，这个效率要比用户线程要高的多。" ID="3a716878b4ceb3195" STYLE="fork">
		</node>
		<node TEXT="多路复用IO模型是通过轮询的方式来检测是否有事件到达，并且对到达的事件逐一进行响应。因此如果没有事件，则一直阻塞在那里，因此这种方式会导致用户线程的阻塞。或则，一旦事件(IO读取,并不是指连接)响应体很大，那么就会导致后续的事件迟迟得不到处理，并且会影响新的事件轮询。" ID="3e416878b7e1ef1951" STYLE="fork">
		</node>
		<node TEXT="" ID="29616878b89e870b4" STYLE="fork">
		</node>
		</node>
		<node TEXT="信号驱动IO模型" ID="2ae16878af135c18f" STYLE="fork">
		<node TEXT="在信号驱动IO模型中，当用户线程发起一个IO请求操作，会给对应的socket注册一个信号函数，然后用户线程会继续执行。" ID="18d16878b22c69078" STYLE="fork">
		</node>
		<node TEXT="当内核数据就绪时会发送一个信号给用户线程，用户线程接收到信号之后，便在信号函数中调用IO读写操作来进行实际的IO请求操作。" ID="2c416878b2048a07a" STYLE="fork">
		</node>
		<node TEXT="但实际上,线程还是阻塞在内核拷贝数据到用户线程的阶段." ID="37016878b206e21081" STYLE="fork">
		</node>
		<node TEXT="" ID="2c616878b2568a15a" STYLE="fork">
		</node>
		</node>
		<node TEXT="异步IO模型" ID="26416878af1c540de" STYLE="fork">
		<node TEXT="异步IO模型是比较理想的IO模型，在异步IO模型中，当用户线程发起read操作之后，立刻就可以开始去做其它的事。" ID="1ff16878bc61ee00b" STYLE="fork">
		</node>
		<node TEXT="从内核的角度，当它受到一个asynchronous read之后，它会立刻返回，说明read请求已经成功发起了，因此不会对用户线程产生任何block。内核会等待数据准备完成，然后将数据拷贝到用户线程。完成后,内核会给用户线程发送一个信号，告诉它read操作完成了。" ID="3d016878bb3fd711e" STYLE="fork">
		</node>
		<node TEXT="在异步IO模型中，IO操作的两个阶段都不会阻塞用户线程，这两个阶段都是由内核自动完成，然后发送一个信号告知用户线程操作已完成。用户线程中不需要再次调用IO函数进行具体的读写。" ID="18216878bc363d191" STYLE="fork">
		</node>
		<node TEXT="与信号驱动模型有所不同的，在信号驱动模型中，当用户线程接收到信号表示数据已经就绪，然后需要用户线程调用IO函数进行实际的读写操作；而在异步IO模型中，收到信号表示IO操作已经完成，不需要再在用户线程中调用iO函数进行实际的读写操作。" ID="37e16878bc363d03b2" STYLE="fork">
		</node>
		<node TEXT="注意，异步IO是需要操作系统的底层支持，在Java 7中，提供了Asynchronous IO。" ID="17016878bc363d0d73" STYLE="fork">
		</node>
		<node TEXT="" ID="1fc16878baf21f05d" STYLE="fork">
		</node>
		</node>
		<node TEXT="前面四种IO模型实际上都属于同步IO，只有最后一种是真正的异步IO，因为无论是多路复用IO还是信号驱动模型，IO操作的第2个阶段(将数据拷贝到用户线程)都会引起用户线程阻塞，也就是内核进行数据拷贝的过程都会让用户线程阻塞。" ID="3c116878af1cdc148" STYLE="fork">
		</node>
		</node>
		<node TEXT="引用" ID="1fd168785e400d13a" STYLE="bubble" POSITION="right">
		<node TEXT="https://mp.weixin.qq.com/s/bRHxWXaeP_So6QfFDh1dfg" ID="296168785e54bd18a" STYLE="fork">
		</node>
		<node TEXT="https://www.ibm.com/developerworks/cn/education/java/j-nio/j-nio.html" ID="d516878bdd49e057" STYLE="fork">
		</node>
		<node TEXT="Hollis知识星球https://t.zsxq.com/qN7YvR7" ID="7f16878be21e70ef" STYLE="fork">
		</node>
		</node>
</node>
</map>